#---
# Excerpted from "Advanced Rails Recipes",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_arr for more book information.
#---
# Filters added to this controller apply to all controllers in the application.
# Likewise, all the methods added will be available for all controllers.


class ApplicationController < ActionController::Base
  around_filter :set_encryption_password
  
  helper :all # include all helpers, all the time

  # See ActionController::RequestForgeryProtection for details
  # Uncomment the :secret if you're not using the cookie session store
  protect_from_forgery # :secret => 'ae81a8cbcfc43504c286064a52b32155'
  


  private
  
  def set_encryption_password    
    if request.headers['HTTP_X_PASSWORD'].blank?
      raise StandardError, "No password was provided" 
    end
    
    begin      
      CreditCard.password = request.headers['HTTP_X_PASSWORD']
      yield
    ensure
      CreditCard.password = nil
    end
  end
  
end

