#---
# Excerpted from "Advanced Rails Recipes",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_arr for more book information.
#---
class Purchase < ActiveRecord::Base
  serialize :receipt
  belongs_to :credit_card
  
  def amount_in_cents
    (amount.round(2) * 100).to_i
  end
  
  private
  def charge_credit_card
    credit_card.decrypt_number
    
    response = gateway.purchase(amount_in_cents, credit_card, 
                :order_id => order,
                :description => description
               )
    
    self.test = response.test?
    self.reference = response.authorization
    self.message = response.message
    self.receipt = response.params

    if !response.success?
      errors.add_to_base(message)
      return false
    end
  end
  
  def gateway
    @gateway ||= ActiveMerchant::Billing::BraintreeGateway.
                   new(:login => 'demo', :password => 'password')
  end

  before_create :charge_credit_card
  validates_presence_of :amount, :description, :order, :credit_card_id
end
