#---
# Excerpted from "Advanced Rails Recipes",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_arr for more book information.
#---
require File.dirname(__FILE__) + '/../test_helper'

class CreditCardsControllerTest < ActionController::TestCase
  
  def setup
    @card_hash = {
      :first_name => 'Cody',
      :last_name => 'Fauser',
      :number => '4242424242424242',
      :month => '8',
      :year => '2008',
      :brand => 'visa'
    }
    
    @request.headers['HTTP_X_PASSWORD'] = 'My really secret password'
  end
  
  def test_password_not_provided
    @request.headers['HTTP_X_PASSWORD'] = nil

    assert_raise(StandardError) do
      post :create
    end
  end
  
  def test_successful_creation
    assert_difference 'CreditCard.count' do
      post :create, :credit_card => @card_hash
      assert_response :created
    end
  end
  
  def test_invalid_creation
    @card_hash[:number] = nil
    
    assert_no_difference 'CreditCard.count' do
      post :create, :credit_card => @card_hash
      assert_response :unprocessable_entity
    end
  end
end
