#---
# Excerpted from "Advanced Rails Recipes",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_arr for more book information.
#---
require File.dirname(__FILE__) + '/../test_helper'

class PurchasesControllerTest < ActionController::TestCase
  def setup
     @request.headers['HTTP_X_PASSWORD'] = 'My really secret password'
  end

  def test_password_not_provided
    @request.headers['HTTP_X_PASSWORD'] = nil

    assert_raise(StandardError) do
      post :create
    end
  end
  
  def test_successful_purchase
    assert_difference 'Purchase.count' do
      post :create, 
        :purchase => {
          :amount => '1.00',
          :description => 'Subscription Fee',
          :order => '1000',
          :credit_card => credit_cards(:visa)
        }

      assert_response :created
    end
  end
  
  def test_unsuccesful_purchase
    assert_no_difference 'Purchase.count' do
      post :create, 
        :purchase => {
          :amount => '1.00',
          :description => 'Subscription Fee',
          :order => '1000',
          :credit_card => credit_cards(:invalid)
        }

      assert_response :unprocessable_entity
    end
  end
end
