#---
# Excerpted from "Advanced Rails Recipes",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_arr for more book information.
#---
require File.dirname(__FILE__) + '/../test_helper'

class EncryptionTest < Test::Unit::TestCase
  include Encryption
  
  def setup
    @data = '4242424242424242'
    @salt = [rand(2**64 - 1)].pack("Q")  
    @password = 'My really secret password'
  end 
  
  def test_encryption_and_decryption
    encrypted_data = encrypt(@data, @password, @salt)
    assert_equal @data, decrypt(encrypted_data, @password, @salt)
  end
  
  def test_encryption_and_decryption
    encrypted_data = encrypt(@data, @password, @salt)
    assert_equal @data, decrypt(encrypted_data, @password, @salt)
  end
  
  def test_encryption_and_decryption_with_invalid_password
    encrypted_data = encrypt(@data, @password, @salt)
    
    assert_raises(OpenSSL::CipherError) do
      decrypt(encrypted_data, 'incorrect password', @salt)
    end
  end
end