#---
# Excerpted from "Advanced Rails Recipes",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_arr for more book information.
#---
module ActsAsFerret

  # mixed into the FerretResult and AR classes calling acts_as_ferret
  module ResultAttributes
    # holds the score this record had when it was found via
    # acts_as_ferret
    attr_accessor :ferret_score

    attr_accessor :ferret_rank
  end

  class FerretResult
    include ResultAttributes
    attr_accessor :id

    def initialize(model, id, score, data = {})
      @model = model.constantize
      @id = id
      @ferret_score = score
      @data = data
    end
    
    def method_missing(method, *args)
      if @ar_record || @data[method].nil?
        ferret_load_record unless @ar_record
        @ar_record.send method, *args
      else
        @data[method]
      end
    end

    def ferret_load_record
      @ar_record = @model.find(id)
    end
  end
end
