#---
# Excerpted from "Advanced Rails Recipes",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_arr for more book information.
#---
module ActsAsFerret

  # base class for local and remote indexes
  class AbstractIndex

    attr_reader :aaf_configuration
    attr_accessor :logger
    def initialize(aaf_configuration)
      @aaf_configuration = aaf_configuration
      @logger = Logger.new("#{RAILS_ROOT}/log/ferret_index.log")
    end
    
    class << self
      def proxy_method(name, *args)
        define_method name do |*args|
          @server.send name, model_class_name, *args
        end
      end

      def index_proxy_method(*names)
        names.each do |name|
          define_method name do |*args|
            @server.send :"index_#{name}", model_class_name, *args
          end
        end
      end

    end
  end

end
