#---
# Excerpted from "Advanced Rails Recipes",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_arr for more book information.
#---
module ActsAsFerret
  
  class SharedIndex < LocalIndex

    # build a ferret query matching only the record with the given id and class
    def query_for_record(id, class_name)
      returning bq = Ferret::Search::BooleanQuery.new do
        bq.add_query(Ferret::Search::TermQuery.new(:id,         id.to_s),    :must)
        bq.add_query(Ferret::Search::TermQuery.new(:class_name, class_name), :must)
      end
    end

  end
end
