#---
# Excerpted from "Advanced Rails Recipes",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_arr for more book information.
#---
class User < ActiveRecord::Base
    
  validates_presence_of :name

  has_many :registrations, :dependent => :destroy
  has_many :events, :through => :registrations, :order => 'events.starts_at'

  has_and_belongs_to_many :tags
  
  def register_for(event)
    return false if self.events.find_by_id(event.id)
    registration = event.registrations.build(:user => self)
    registration.save
  end

end
