#---
# Excerpted from "Advanced Rails Recipes",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_arr for more book information.
#---
class Pdf < ActiveRecord::Base
  
  acts_as_state_machine :initial => :pending
  
  state :pending
  state :processing
  state :complete
  state :error
  
  event :start_pdf_generation do
    transitions :from => :pending, :to => :processing
  end
  
  event :finish_pdf_generation do
    transitions :from => :processing, :to => :complete
  end
  
  event :processing_error do
    transitions :from => :processing, :to => :error
  end
  
  def self.find_for_pdf_generation
    find(:first, 
         :conditions => "state = 'pending'", 
         :order => "priority, created_at")
  end

  def generate_pdf
    logger.info("Generating #{title} PDF...")
    # Insert your long-running code here to generate PDFs.
  end
end
