#---
# Excerpted from "Advanced Rails Recipes",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_arr for more book information.
#---
require File.dirname(__FILE__) + '/../app/models/pdf.rb'

class GeneratePdf
  
  def self.run
    begin
      pdf = Pdf.find_for_pdf_generation
      raise ActiveRecord::RecordNotFound if pdf.nil?
      
      pdf.start_pdf_generation!
      pdf.generate_pdf
      pdf.finish_pdf_generation!
    
    rescue ActiveRecord::StaleObjectError
      # do nothing
    rescue ActiveRecord::RecordNotFound
      sleep 10
    rescue
      return unless pdf
      pdf.processing_error!
      pdf.update_attributes(:processing_error_message => "unknown error: #{$!}")
    end    
  end
end
