#---
# Excerpted from "Advanced Rails Recipes",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_arr for more book information.
#---
class ChargesController < ApplicationController

  def index
    @unpaid_customers = @current_shop.unpaid_customers
  end
  
  
  def create
    customers_to_charge = []
    params[:charge_customer].each do |customer_id, charge|
      customers_to_charge << customer_id if charge == "yes"
    end

    session[:bill_job_key] = @current_shop.start_billing(customers_to_charge)
    
    redirect_to :action => 'check_bill_status'
  end
  
  
  
  def check_bill_status
    @percent_complete = Shop.billing_status(session[:bill_job_key])
    
    if request.xhr?
      if @percent_complete == 100
        render :update do |page| 
          flash[:notice] = "Billing is complete!"
          session[:bill_job_key] = nil
          page.redirect_to :action => "index" 
        end
      else
        render :update do |page|
          page[:billingStatus].setStyle :width => "#{@percent_complete * 2}px"
          page[:billingStatus].replace_html "#{@percent_complete}%"
        end
      end
    end
  end
  

end
