#---
# Excerpted from "Advanced Rails Recipes",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_arr for more book information.
#---
class SessionsController < ApplicationController

  skip_before_filter :login_required
  
  def new
  end

  def create
    @shop =  Shop.find_by_login(params[:login])
    if @shop
      session[:shop_id] = @shop.id
      flash[:notice] = "Welcome back to #{@shop.name}!"
      redirect_to charges_url
    else
      flash.now[:error] = "Invalid login!"
      render :action => 'new'
    end
  end

  def destroy
    reset_session
    flash[:notice] = "You've been logged out."
    redirect_to new_session_url
  end

end