#---
# Excerpted from "Advanced Rails Recipes",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_arr for more book information.
#---
class Shop < ActiveRecord::Base
  has_many :customers
  validates_presence_of :name, :login, :password
  
  def unpaid_customers
    customers.find(:all, :conditions => "last_billed_at is null")
  end
  
  def start_billing(customers_to_charge)
    MiddleMan.new_worker(:worker  => :billing_worker,
                         :job_key => self.id,
                         :data    => customers_to_charge)
  end
  
  def self.billing_status(job_key)
    status = MiddleMan.ask_status(:worker  => :billing_worker,
                                  :job_key => job_key)
    status[:percent_complete]
  end
  
end
