#---
# Excerpted from "Advanced Rails Recipes",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_arr for more book information.
#---
class BillingWorker < BackgrounDRb::MetaWorker
  set_worker_name :billing_worker
  set_no_auto_load(true)

  def create(args=nil)
    register_status(:percent_complete => 0)
    args.each_with_index do |customer_id, index| 
      c = Customer.find(customer_id)
      c.bill!
      percent_complete = ((index + 1) * 100) / args.length
      logger.info "Billing is #{percent_complete}% complete..."
      register_status(:percent_complete => percent_complete)
    end
    exit
  end
  
end