#---
# Excerpted from "Advanced Rails Recipes",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_arr for more book information.
#---
class LogWorker < Packet::Worker
  set_worker_name :log_worker
  #set_no_auto_load(true)
  attr_accessor :log_file
  def worker_init
    @log_file = Logger.new("#{RAILS_HOME}/log/backgroundrb_#{CONFIG_FILE[:backgroundrb][:port]}.log")
  end

  def receive_data p_data
    case p_data[:type]
    when :request: process_request(p_data)
    when :response: process_response(p_data)
    end
  end

  def process_request(p_data)
    log_data = p_data[:data]
    @log_file.info(log_data)
  end

  def process_response
    puts "Not implemented and needed"
  end
end


