#---
# Excerpted from "Advanced Rails Recipes",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_arr for more book information.
#---
module ActionController
  class Base    
    def process_with_browser_profiling(request, response, 
                                       method = :perform_action, 
                                       *arguments)

      if request.parameters.key?('browser_profile!')
        require 'ruby-prof'
        
        # Profile only the action
        profile_results = RubyProf.profile {
          response = process_without_browser_profiling(request, response, 
                                                       method, *arguments)
        }

        # Use RubyProf's built in HTML printer to format the results
        printer = RubyProf::GraphHtmlPrinter.new(profile_results)     
        
        # Append the results to the HTML response
        response.body << printer.print("", 0)

        # Reset the content length (for Rails 2.0)
        response.send("set_content_length!")
        
        response
      else
        process_without_browser_profiling(request, response, 
                                          method, *arguments)
      end
    end
    alias_method_chain :process, :browser_profiling
  end 
end