#---
# Excerpted from "Advanced Rails Recipes",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_arr for more book information.
#---
class User < ActiveRecord::Base

  has_one :picture
  has_and_belongs_to_many :tags

  acts_as_cached :ttl => 5.minutes

  def self.find_latest
    find :all, :order => 'users.id desc', 
               :limit => 50, 
               :include => [:tags, :picture]
  end
end
