#---
# Excerpted from "Advanced Rails Recipes",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_arr for more book information.
#---
require File.dirname(__FILE__) + '/../test_helper'

class UserTest < Test::Unit::TestCase


  context "Calling #cached(:find_latest)" do
    should "should call #find_latest if not cached" do 
      flexmock(User).should_receive(:fetch_cache).and_return(nil) 
      assert_equal User.find_latest, User.cached(:find_latest) 
    end
    
    should "should return if cached" do 
      flexmock(User).should_receive(:get_cache).and_return(true) 
      flexmock(User).should_receive(:find_latest).never 
      User.cached(:find_latest)  
    end
  end

end