#---
# Excerpted from "Advanced Rails Recipes",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_arr for more book information.
#---
require 'memcache'
puts "=> You should be using the `memcache-client' gem.  You're using RubyMemcache!" if Object.const_defined?(:RubyMemcache)

begin
  require 'mem_cache_with_consistent_hashing'
rescue LoadError
else
  puts "=> MemCacheWithConsistentHashing being used."
end

require 'acts_as_cached'

Object.send :include, ActsAsCached::Mixin

unless File.exists? config_file = File.join(RAILS_ROOT, 'config', 'memcached.yml')
  error = "No config file found.  Make sure you used `script/plugin install' and have memcached.yml in your config directory."
  puts error
  logger.error error
  exit!
end

ActsAsCached.config = YAML.load(ERB.new(IO.read(config_file)).result)

begin
  require 'extensions' 
rescue LoadError
end
