#---
# Excerpted from "Advanced Rails Recipes",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_arr for more book information.
#---
require File.join(File.dirname(__FILE__), 'helper')

module ActsAsCached
  module Extensions
    module ClassMethods
      def user_defined_class_method
        true
      end
    end

    module InstanceMethods
      def user_defined_instance_method
        true
      end
    end
  end
end

context "When Extensions::ClassMethods exists" do
  include StoryCacheSpecSetup

  specify "caching classes should extend it" do
    Story.singleton_methods.should.include 'user_defined_class_method'
  end
end

context "When Extensions::InstanceMethods exists" do
  include StoryCacheSpecSetup

  specify "caching classes should include it" do
    Story.instance_methods.should.include 'user_defined_instance_method'
  end
end
