#---
# Excerpted from "Advanced Rails Recipes",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_arr for more book information.
#---
class CandiesController < ApplicationController
  # GET /candies
  # GET /candies.xml
  def index
    @candies = Candy.find(:all)

    respond_to do |format|
      format.html # index.html.erb
      format.xml  { render :xml => @candies }
    end
  end

  # GET /candies/1
  # GET /candies/1.xml
  def show
    @candy = Candy.find(params[:id])

    respond_to do |format|
      format.html # show.html.erb
      format.xml  { render :xml => @candy }
    end
  end

  # GET /candies/new
  # GET /candies/new.xml
  def new
    @candy = Candy.new

    respond_to do |format|
      format.html # new.html.erb
      format.xml  { render :xml => @candy }
    end
  end

  # GET /candies/1/edit
  def edit
    @candy = Candy.find(params[:id])
  end

  # POST /candies
  # POST /candies.xml
  def create
    @candy = Candy.new(params[:candy])

    respond_to do |format|
      if @candy.save
        flash[:notice] = 'Candy was successfully created.'
        format.html { redirect_to(@candy) }
        format.xml  { render :xml => @candy, :status => :created, :location => @candy }
      else
        format.html { render :action => "new" }
        format.xml  { render :xml => @candy.errors, :status => :unprocessable_entity }
      end
    end
  end

  # PUT /candies/1
  # PUT /candies/1.xml
  def update
    @candy = Candy.find(params[:id])

    respond_to do |format|
      if @candy.update_attributes(params[:candy])
        flash[:notice] = 'Candy was successfully updated.'
        format.html { redirect_to(@candy) }
        format.xml  { head :ok }
      else
        format.html { render :action => "edit" }
        format.xml  { render :xml => @candy.errors, :status => :unprocessable_entity }
      end
    end
  end

  # DELETE /candies/1
  # DELETE /candies/1.xml
  def destroy
    @candy = Candy.find(params[:id])
    @candy.destroy

    respond_to do |format|
      format.html { redirect_to(candies_url) }
      format.xml  { head :ok }
    end
  end
end
