#---
# Excerpted from "Advanced Rails Recipes",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_arr for more book information.
#---
require File.dirname(__FILE__) + '/../test_helper'

class CandiesControllerTest < ActionController::TestCase
  def test_should_get_index
    get :index
    assert_response :success
    assert_not_nil assigns(:candies)
  end

  def test_should_get_new
    get :new
    assert_response :success
  end

  def test_should_create_candy
    assert_difference('Candy.count') do
      post :create, :candy => { }
    end

    assert_redirected_to candy_path(assigns(:candy))
  end

  def test_should_show_candy
    get :show, :id => candies(:one).id
    assert_response :success
  end

  def test_should_get_edit
    get :edit, :id => candies(:one).id
    assert_response :success
  end

  def test_should_update_candy
    put :update, :id => candies(:one).id, :candy => { }
    assert_redirected_to candy_path(assigns(:candy))
  end

  def test_should_destroy_candy
    assert_difference('Candy.count', -1) do
      delete :destroy, :id => candies(:one).id
    end

    assert_redirected_to candies_path
  end
end
