#---
# Excerpted from "Advanced Rails Recipes",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_arr for more book information.
#---
module ConstantCache
  module ClassMethods
    def caches_constants
      find(:all).each do |instance|
        const = instance.name.gsub(/\s+/, '_').upcase
        if const_defined?(const)
          raise RuntimeError, 
               "Constant #{self.to_s}::#{const} has already been defined"
        else
          const_set(const, instance)
        end
      end
    end
  end
end

ActiveRecord::Base.send(:extend, ConstantCache::ClassMethods)