#---
# Excerpted from "Advanced Rails Recipes",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_arr for more book information.
#---
require File.dirname(__FILE__) + '/../test_helper'

class StudentsControllerTest < ActionController::TestCase
  tests StudentsController

  def test_should_get_index
    get :index
    assert_response :success
    assert_not_nil assigns(:students)
  end

  def test_should_get_new
    get :new
    assert_response :success
  end

  def test_should_create_student
    assert_difference('Student.count') do
      post :create, :student => {:name => "Charlie Brown", :ssn => "123-12-1234"}
    end

    assert_redirected_to student_path(assigns(:student))
  end

  def test_should_show_student
    get :show, :id => 1
    assert_response :success
  end

  def test_should_get_edit
    get :edit, :id => 1
    assert_response :success
  end

  def test_should_update_student
    put :update, :id => 1, :student => {:name => "Charlie Brown", :ssn => "123-12-1234"}
    assert_redirected_to student_path(assigns(:student))
  end

  def test_should_destroy_student
    assert_difference('Student.count', -1) do
      delete :destroy, :id => 1
    end

    assert_redirected_to students_path
  end
end
