#---
# Excerpted from "Advanced Rails Recipes",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_arr for more book information.
#---
require File.dirname(__FILE__) + '/../test_helper'

class AccountTest < ActiveSupport::TestCase

  def test_should_delegate_free_to_subscription
    account = Account.find(:first)
    subscription = account.subscription
    subscription.free = true
    subscription.save!
    assert_equal(subscription.free?, account.free?)
    
    subscription.free = false
    subscription.save!
    assert_equal(subscription.free?, account.free?)
  end
  
  def test_should_delegate_paying_to_subscription
    account = Account.find(:first)
    subscription = account.subscription
    subscription.paying = true
    subscription.save!
    assert_equal(true, account.paying?)
    
    subscription.paying = false
    subscription.save!
    account.reload
    assert_equal(false, account.paying?)
  end
  
  def test_should_delegate_overdue_to_payment
    account = Account.find(:first)
    payment = account.subscription.last_payment
    payment.overdue = true
    payment.save!
    assert_equal(true, account.overdue?)
    
    payment.overdue = false
    payment.save!
    assert_equal(false, account.overdue?)
  end
  
  def test_should_delegate_to_silent_nil_if_no_subscription_exists
    account = Account.new
    assert_equal(nil, account.free?)
  end
end
