#---
# Excerpted from "Advanced Rails Recipes",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_arr for more book information.
#---
class SessionsController < ApplicationController

  skip_before_filter :login_required

  def create
    unless params[:name].blank?
      session[:user_id] = 1
      cookies[:user_name]  = {:value => params[:name]}
      redirect_to home_url
    else
      flash.now[:error] = "Invalid name or password!"
      render :action => :new
    end
  end
  
  def destroy
    reset_session
    cookies.delete :user_name
    flash[:notice] = "You've been logged out."
    redirect_to login_url
  end

end