#---
# Excerpted from "Advanced Rails Recipes",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_arr for more book information.
#---
module ApplicationHelper


  def page_title
    title = @page_title ? "| #{@page_title}" : ''
    %(<title>Bookstore #{title}</title>)
  end



  def meta(name, content)
    %(<meta name="#{name}" content="#{content} />")
  end



  def meta_description
    if @book and !@book.new_record?
      "Information about #{@book.title} by #{@book.author}."
    else
      "Books for programmers by programmers"
    end
  end



  def meta_keywords
    if @book and !@book.new_record?
      [@book.title, 
       @book.author, 
       "#{@book.edition.ordinalize} Edition", 
       @book.isbn, 
       @book.pubdate.to_s(:month_year)].join(',')
    else
      %w(books programmers).join(',')
    end 
  end

  
end
