#---
# Excerpted from "Advanced Rails Recipes",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_arr for more book information.
#---
# Filters added to this controller apply to all controllers in the application.
# Likewise, all the methods added will be available for all controllers.

class ApplicationController < ActionController::Base
  helper :all # include all helpers, all the time

  # See ActionController::RequestForgeryProtection for details
  # Uncomment the :secret if you're not using the cookie session store
  protect_from_forgery # :secret => '6cf16d6593c539ad760052fa7b7a3a12'
  
  
  before_filter :login_required
  before_filter :require_valid_email

  def login_required
    @user = User.find(session[:user_id])
    redirect_to new_session_path and return false if @user.nil?
  end
  
  def require_valid_email
    unless @user.should_email?
      render :action=> "users/validate_email"
      return false
    end
  end
  
  
end
