#---
# Excerpted from "Advanced Rails Recipes",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_arr for more book information.
#---

class Bounce < ActiveRecord::Base
  belongs_to :user
  

  
  HEADER = "X-User-ID"
  FROM_STRING = "bounces-"
  
  
  def self.create_for(email)
    body = email.to_s

    return unless body.match(/MAILER-DAEMON/i)

    email.to.each do |recipient|
      address = recipient.split(/@/)[0]
      if address and match = address.match(/bounces-(\d+)/)
        process_match(match, email)
      end
    end
    
    if match = email.to_s.match(/X-User-ID:\s+(\d+)/mi)
      process_match(match, email)
    end
  end
  
  
  
  def self.process_match(match, email)
    user_id = match[1]
    user = User.find(user_id)
    
    cleanup_old_bounces(user)
    bounce = create!(:user => user, :body => email.to_s)
    user.email_bounced(bounce)
  end
  
  def self.cleanup_old_bounces(user)
    old = user.bounces.find(:all,:conditions => ["created_at < ?", 21.days.ago])
    old.each(&:destroy)
    user.bounces.reload
  end
  
  

end


