#---
# Excerpted from "Advanced Rails Recipes",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_arr for more book information.
#---

class UserMailer < ActionMailer::Base
  
  def new_comment(user, comment)
    setup_for_user(user)
    @subject += " A new comment has been left for you!"
    @body[:comment] = comment
  end
  
  def setup_for_user(user)
    recipients  user.email
    from  "No Reply <bounces-#{user.id}@example.com>"
    @subject = "[APP_NAME] "
    @body[:user] = user
  end

=BEGIN

  def setup_for_user(user)
    recipients  user.email
    from  "No Reply <bounces@example.com>"
    @subject = "[APP_NAME] "
    headers["X-User-ID"] = user.id
    @body[:user] = user
  end

=END


  def receive(email)
    Bounce.create_for(email)
  end
  
end
