#---
# Excerpted from "Advanced Rails Recipes",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_arr for more book information.
#---
require 'ezcrypto'

class MasterCryptoProvider

  CONFIG = YAML.load_file(RAILS_ROOT + 
             '/config/crypto.yml')[ENV['RAILS_ENV']].symbolize_keys
  
  class << self
    def encrypt(field)
      key.encrypt field
    end
    
    def decrypt(field)
      key.decrypt field
    end
    
    def key
      EzCrypto::Key.with_password CONFIG[:master_key], CONFIG[:salt]
    end
  end
end
