#---
# Excerpted from "Advanced Rails Recipes",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_arr for more book information.
#---
require File.dirname(__FILE__) + '/../test_helper'

class RestaurantsControllerTest < ActionController::TestCase
  def test_should_get_index
    get :index
    assert_response :success
    assert_not_nil assigns(:restaurants)
  end

  def test_should_get_new
    get :new
    assert_response :success
  end

  def test_should_create_restaurant
    assert_difference('Shop.count') do
      post :create, :restaurant => { }
    end

    assert_redirected_to restaurant_path(assigns(:restaurant))
  end

  def test_should_show_restaurant
    get :show, :id => 1
    assert_response :success
  end

  def test_should_get_edit
    get :edit, :id => 1
    assert_response :success
  end

  def test_should_update_restaurant
    put :update, :id => 1, :restaurant => { }
    assert_redirected_to restaurant_path(assigns(:restaurant))
  end

  def test_should_destroy_restaurant
    assert_difference('Shop.count', -1) do
      delete :destroy, :id => 1
    end

    assert_redirected_to restaurants_path
  end
end
