#---
# Excerpted from "Advanced Rails Recipes",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_arr for more book information.
#---
# Note: If you are using FastCGI you may need to hard-code the hostname here 
# instead of using Socket.gethostname


class RecipesLogFormatter

  def call(severity, time, program_name, message)

    datetime = time.strftime("%b %d %H:%M:%S")
    message      = (String === message ? message : msg.inspect)
    "#{datetime} -- #{message}\n" 


    datetime = time.strftime("%b %d %H:%M:%S")
    process  = "rails[#{$PID}]"
    hostname = Socket.gethostname.split('.')[0]
    message  = (String === message ? 
                  message : message.inspect).gsub(/\n/, '').strip
    "#{datetime} #{hostname} #{process}: #{message}\n"

  end

end

