#---
# Excerpted from "Advanced Rails Recipes",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_arr for more book information.
#---
class PeopleController < ApplicationController

  before_filter :load_person, :except => [:index, :new, :create]
  
  def create
    @person = Person.create!(params[:person])
    
    respond_to do |format|
      format.html { redirect_to @person }
    end
  end
  
  def show
    respond_to do |format|
      format.html
    end
  end
  
  def update
    @person.update_attributes!(params[:person])
    
    respond_to do |format|
      format.html
      format.js
    end
  end
  
  def destroy
    @person.destroy
    
    respond_to do |format|
      format.html { redirect_to people_url }
    end
  end
  
  def index
    @people = Person.find(:all)
    
    respond_to do |format|
      format.html
    end
  end
  
  def new
    @person = Person.new
    
    respond_to do |format|
      format.html
    end
  end
  
  def edit
    respond_to do |format|
      format.html
      format.js
    end
  end
  
protected

  def load_person
    @person = Person.find(params[:id])
  end

end
