/***
 * Excerpted from "Advanced Rails Recipes",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material, 
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/fr_arr for more book information.
***/
// Controls showing a preview element when the user hovers over a certain link

var PeoplePreview = Behavior.create({
  preview: null,
  
  initialize: function(preview_selector) {
    this.preview = this.element.down(preview_selector);
    this.preview.hide();
  },
  
  onmouseover: function() {
    this.preview.show();
  },
  
  onmouseout: function() {
    this.preview.hide();
  }
});


// Prompts the user to confirm a delete before proceeding

var DeleteConfirmation = Behavior.create({
  onsubmit: function(evt) {
    if (confirm('Really delete this item?')) {
      return true; // Allow the delete
    } else {
      evt.stop();
      return false;
    }
  }
});


// Enabling this applies all matching Behaviors after each AJAX request.  Dan
// Webb doesn't recommend it for performance reasons, but it makes these
// these examples much simpler.  See this thread for more info:
//
// http://groups.google.com/group/low-pro/browse_thread/thread/de9ec80558af78d3/9f2d3a717242dbd9#9f2d3a717242dbd9


Event.addBehavior.reassignAfterAjax = true;
Event.addBehavior({
  '.people_list li': PeoplePreview('.preview'),
  '.delete_person': DeleteConfirmation,
  '.edit_person': Remote
});

