#---
# Excerpted from "Advanced Rails Recipes",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_arr for more book information.
#---
require File.dirname(__FILE__) + '/../spec_helper'

describe PeopleHelper, "for a new person" do
  
  before do
    @person = Person.new
  end
  
  it "should call form_title and render a create message" do
    form_title.should == "Create a new person"
  end
  
  it "should call back_path and link to the people listing" do
    back_path.should == people_path
  end
  
  it "should call form_id and get edit_new_person" do
    form_id.should == dom_id(@person, 'edit')
  end
end

describe PeopleHelper, "for an existing person" do
  
  before do
    @person = Person.create(:name => 'Horatio', :url => 'http://horatio.com')    
  end
  
  it "should call form_title and render an edit message" do
    form_title.should == "Edit #{@person.name}"
  end
  
  it "should call back_path and link to the person" do
    back_path.should == person_path(@person)
  end
  
  it "should call form_id and get edit_person_14" do
    form_id.should == dom_id(@person, 'edit')
  end
end