#---
# Excerpted from "Advanced Rails Recipes",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_arr for more book information.
#---
require File.dirname(__FILE__) + '/../test_helper'

class ShoutsControllerTest < ActionController::TestCase
  def test_should_get_index
    get :index
    assert_response :success
    assert_not_nil assigns(:shouts)
  end

  def test_should_get_new
    get :new
    assert_response :success
  end

  def test_should_create_shout
    assert_difference('Shout.count') do
      post :create, :shout => { }
    end

    assert_redirected_to shout_path(assigns(:shout))
  end

  def test_should_show_shout
    get :show, :id => 1
    assert_response :success
  end

  def test_should_get_edit
    get :edit, :id => 1
    assert_response :success
  end

  def test_should_update_shout
    put :update, :id => 1, :shout => { }
    assert_redirected_to shout_path(assigns(:shout))
  end

  def test_should_destroy_shout
    assert_difference('Shout.count', -1) do
      delete :destroy, :id => 1
    end

    assert_redirected_to shouts_path
  end
end
