#---
# Excerpted from "Advanced Rails Recipes",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_arr for more book information.
#---
class GadgetsController < ApplicationController

  # GET /gadgets
  # GET /gadgets.xml
  def index
    @gadgets = Gadget.find(:all)

    respond_to do |format|
      format.html # index.html.erb
      format.xml  { render :xml => @gadgets }
    end
  end

  # GET /gadgets/1
  # GET /gadgets/1.xml
  def show
    @gadget = Gadget.find(params[:id])

    respond_to do |format|
      format.html # show.html.erb
      format.xml  { render :xml => @gadget }
    end
  end

  # GET /gadgets/new
  # GET /gadgets/new.xml
  def new
    @gadget = Gadget.new

    respond_to do |format|
      format.html # new.html.erb
      format.xml  { render :xml => @gadget }
    end
  end

  # GET /gadgets/1/edit
  def edit
    @gadget = Gadget.find(params[:id])
  end

  # POST /gadgets
  # POST /gadgets.xml
  
  def create
    @gadget = Gadget.new(params[:gadget])

    if @gadget.save
      flash[:notice] = "Gadget was successfully created."
      redirect_to @gadget
    else
      flash[:error] = "Whoops, gadget couldn't be created."
      render :action => "new"
    end
  end
  

  # PUT /gadgets/1
  # PUT /gadgets/1.xml
  def update
    @gadget = Gadget.find(params[:id])

    respond_to do |format|
      if @gadget.update_attributes(params[:gadget])
        flash[:notice] = 'Gadget was successfully updated.'
        format.html { redirect_to(@gadget) }
        format.xml  { head :ok }
      else
        format.html { render :action => "edit" }
        format.xml  { render :xml => @gadget.errors, :status => :unprocessable_entity }
      end
    end
  end

  # DELETE /gadgets/1
  # DELETE /gadgets/1.xml
  def destroy
    @gadget = Gadget.find(params[:id])
    @gadget.destroy

    respond_to do |format|
      format.html { redirect_to(gadgets_url) }
      format.xml  { head :ok }
    end
  end
end
