#---
# Excerpted from "Advanced Rails Recipes",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_arr for more book information.
#---

require File.dirname(__FILE__) + '/../test_helper'

class GadgetsControllerTest < ActionController::TestCase
  
  test_create_invalid_fails
  
  
  
  def setup
    @controller = GadgetsController.new
    @request    = ActionController::TestRequest.new
    @response   = ActionController::TestResponse.new
  end

  def test_should_get_index
    get :index
    assert_response :success
    assert_not_nil assigns(:gadgets)
  end

  def test_should_get_new
    get :new
    assert_response :success
  end

  
  
  def test_should_create_gadget
    assert_difference('Gadget.count') do
      post :create, :gadget => { :name => "Chronometer", :price => 6 }
    end
    assert_not_nil assigns(:gadget)
    assert_not_nil flash[:notice]
    assert_redirected_to gadget_path(assigns(:gadget))
  end
  
  

  def test_should_show_gadget
    get :show, :id => 1
    assert_response :success
  end

  def test_should_get_edit
    get :edit, :id => 1
    assert_response :success
  end

  def test_should_update_gadget
    put :update, :id => 1, :gadget => { }
    assert_redirected_to gadget_path(assigns(:gadget))
  end

  def test_should_destroy_gadget
    assert_difference('Gadget.count', -1) do
      delete :destroy, :id => 1
    end

    assert_redirected_to gadgets_path
  end
  
  
  def test_create_invalid_gadget_fails
    flexmock(Gadget).new_instances.should_receive(:save).
                     once.and_return(false)
    post :create, :gadget => { }
    assert_not_nil assigns(:gadget)
    assert_response :success
    assert_template 'new'
    assert_not_nil flash[:error]
  end
  


end

