#---
# Excerpted from "Advanced Rails Recipes",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_arr for more book information.
#---
require File.dirname(__FILE__) + '/../test_helper'

class RegistrationsControllerTest < ActionController::TestCase
  def test_should_get_index
    get :index
    assert_response :success
    assert_not_nil assigns(:registrations)
  end

  def test_should_get_new
    get :new
    assert_response :success
  end

  def test_should_create_registration
    assert_difference('Registration.count') do
      post :create, :registration => { }
    end

    assert_redirected_to registration_path(assigns(:registration))
  end

  def test_should_show_registration
    get :show, :id => registrations(:one).id
    assert_response :success
  end

  def test_should_get_edit
    get :edit, :id => registrations(:one).id
    assert_response :success
  end

  def test_should_update_registration
    put :update, :id => registrations(:one).id, :registration => { }
    assert_redirected_to registration_path(assigns(:registration))
  end

  def test_should_destroy_registration
    assert_difference('Registration.count', -1) do
      delete :destroy, :id => registrations(:one).id
    end

    assert_redirected_to registrations_path
  end
end
