#---
# Excerpted from "Advanced Rails Recipes",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_arr for more book information.
#---
class OrderPresenter

  def initialize(params)
    params.each_pair do |attribute, value| 
      self.send :"#{attribute}=", value 
    end unless params.nil?    
  end

  def account
    @account ||= UserAccount.new
  end

  def address
    @address ||= Address.new
  end

  def credential
    @credential ||= UserCredential.new
  end

  def save    
    account_saved = account.save 
    address.user_account = account
    credential.user_account = account
    account_saved && address.save && credential.save
  end

  def method_missing(model_attribute, *args)
    model, *method_name = model_attribute.to_s.split("_")
    super unless self.respond_to? model.to_sym
    self.send(model.to_sym).send(method_name.join("_").to_sym, *args)
  end
end