#---
# Excerpted from "Advanced Rails Recipes",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_arr for more book information.
#---
class CreateModels < ActiveRecord::Migration

  def self.up
    create_table :user_accounts do |t|
      t.string :name
    end
    
    create_table :addresses do |t|
      t.string :line_1
      t.string :line_2
      t.string :city
      t.string :state
      t.string :zip_code
      t.integer :user_account_id
    end
    
    create_table :user_credentials do |t|
      t.string :username
      t.string :password
      t.integer :user_account_id
    end
  end

  def self.down
    drop_table :user_accounts
    drop_table :addresses
    drop_table :user_credentials
  end
end
