#---
# Excerpted from "Advanced Rails Recipes",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_arr for more book information.
#---
require File.join(File.dirname(__FILE__), "..", "..", "spec_helper.rb")

describe "/people/index.html.erb" do

  it "should list all the good people in an unordered list" do
    assigns[:people] = [ 
      stub("person1", :full_name => "First Person", 
                      :email => "first@person.com"), 
      stub("person2", :full_name => "Second Person", 
                      :email => "second@person.com") 
    ] 
  
    render '/people/index.html.erb'

    response.should have_tag("ul") do
      with_tag("li") do
        with_tag("div", "First Person")
        with_tag("div", "first@person.com")
      end
      with_tag("li") do
        with_tag("div", "Second Person")
        with_tag("div", "second@person.com")
      end
    end
  end
end