#---
# Excerpted from "Advanced Rails Recipes",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_arr for more book information.
#---
require 'spec/example/configuration'

module Spec
  module Example
    class Configuration
      # All of this is ActiveRecord related and makes no sense if it's not used by the app
      if defined?(ActiveRecord::Base)
        def initialize
          super
          Test::Unit::TestCase.fixture_path = RAILS_ROOT + '/spec/fixtures'
        end

        def use_transactional_fixtures
          Test::Unit::TestCase.use_transactional_fixtures
        end
        def use_transactional_fixtures=(value)
          Test::Unit::TestCase.use_transactional_fixtures = value
        end
      
        def use_instantiated_fixtures
          Test::Unit::TestCase.use_instantiated_fixtures
        end
        def use_instantiated_fixtures=(value)
          Test::Unit::TestCase.use_instantiated_fixtures = value
        end
      
        def fixture_path
          Test::Unit::TestCase.fixture_path
        end
        def fixture_path=(path)
          Test::Unit::TestCase.fixture_path = path
        end
      
        def global_fixtures
          ::Test::Unit::TestCase.fixture_table_names
        end
        def global_fixtures=(fixtures)
          ::Test::Unit::TestCase.fixtures(*fixtures)
        end
      end
    end
  end
end
