#---
# Excerpted from "Advanced Rails Recipes",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_arr for more book information.
#---
class ZodiacSignsController < ApplicationController
  # GET /zodiac_signs
  # GET /zodiac_signs.xml
  def index
    @zodiac_signs = ZodiacSign.find(:all)

    respond_to do |format|
      format.html # index.html.erb
      format.xml  { render :xml => @zodiac_signs }
    end
  end

  # GET /zodiac_signs/1
  # GET /zodiac_signs/1.xml
  def show
    @zodiac_sign = ZodiacSign.find(params[:id])

    respond_to do |format|
      format.html # show.html.erb
      format.xml  { render :xml => @zodiac_sign }
    end
  end

  # GET /zodiac_signs/new
  # GET /zodiac_signs/new.xml
  def new
    @zodiac_sign = ZodiacSign.new

    respond_to do |format|
      format.html # new.html.erb
      format.xml  { render :xml => @zodiac_sign }
    end
  end

  # GET /zodiac_signs/1/edit
  def edit
    @zodiac_sign = ZodiacSign.find(params[:id])
  end

  # POST /zodiac_signs
  # POST /zodiac_signs.xml
  def create
    @zodiac_sign = ZodiacSign.new(params[:zodiac_sign])

    respond_to do |format|
      if @zodiac_sign.save
        flash[:notice] = 'ZodiacSign was successfully created.'
        format.html { redirect_to(@zodiac_sign) }
        format.xml  { render :xml => @zodiac_sign, :status => :created, :location => @zodiac_sign }
      else
        format.html { render :action => "new" }
        format.xml  { render :xml => @zodiac_sign.errors, :status => :unprocessable_entity }
      end
    end
  end

  # PUT /zodiac_signs/1
  # PUT /zodiac_signs/1.xml
  def update
    @zodiac_sign = ZodiacSign.find(params[:id])

    respond_to do |format|
      if @zodiac_sign.update_attributes(params[:zodiac_sign])
        flash[:notice] = 'ZodiacSign was successfully updated.'
        format.html { redirect_to(@zodiac_sign) }
        format.xml  { head :ok }
      else
        format.html { render :action => "edit" }
        format.xml  { render :xml => @zodiac_sign.errors, :status => :unprocessable_entity }
      end
    end
  end

  # DELETE /zodiac_signs/1
  # DELETE /zodiac_signs/1.xml
  def destroy
    @zodiac_sign = ZodiacSign.find(params[:id])
    @zodiac_sign.destroy

    respond_to do |format|
      format.html { redirect_to(zodiac_signs_url) }
      format.xml  { head :ok }
    end
  end
end
