#---
# Excerpted from "Advanced Rails Recipes",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_arr for more book information.
#---
require File.dirname(__FILE__) + '/../spec_helper'

describe ZodiacSignsController do
  describe "route generation" do

    it "should map { :controller => 'zodiac_signs', :action => 'index' } to /zodiac_signs" do
      route_for(:controller => "zodiac_signs", :action => "index").should == "/zodiac_signs"
    end
  
    it "should map { :controller => 'zodiac_signs', :action => 'new' } to /zodiac_signs/new" do
      route_for(:controller => "zodiac_signs", :action => "new").should == "/zodiac_signs/new"
    end
  
    it "should map { :controller => 'zodiac_signs', :action => 'show', :id => 1 } to /zodiac_signs/1" do
      route_for(:controller => "zodiac_signs", :action => "show", :id => 1).should == "/zodiac_signs/1"
    end
  
    it "should map { :controller => 'zodiac_signs', :action => 'edit', :id => 1 } to /zodiac_signs/1/edit" do
      route_for(:controller => "zodiac_signs", :action => "edit", :id => 1).should == "/zodiac_signs/1/edit"
    end
  
    it "should map { :controller => 'zodiac_signs', :action => 'update', :id => 1} to /zodiac_signs/1" do
      route_for(:controller => "zodiac_signs", :action => "update", :id => 1).should == "/zodiac_signs/1"
    end
  
    it "should map { :controller => 'zodiac_signs', :action => 'destroy', :id => 1} to /zodiac_signs/1" do
      route_for(:controller => "zodiac_signs", :action => "destroy", :id => 1).should == "/zodiac_signs/1"
    end
  end

  describe "route recognition" do

    it "should generate params { :controller => 'zodiac_signs', action => 'index' } from GET /zodiac_signs" do
      params_from(:get, "/zodiac_signs").should == {:controller => "zodiac_signs", :action => "index"}
    end
  
    it "should generate params { :controller => 'zodiac_signs', action => 'new' } from GET /zodiac_signs/new" do
      params_from(:get, "/zodiac_signs/new").should == {:controller => "zodiac_signs", :action => "new"}
    end
  
    it "should generate params { :controller => 'zodiac_signs', action => 'create' } from POST /zodiac_signs" do
      params_from(:post, "/zodiac_signs").should == {:controller => "zodiac_signs", :action => "create"}
    end
  
    it "should generate params { :controller => 'zodiac_signs', action => 'show', id => '1' } from GET /zodiac_signs/1" do
      params_from(:get, "/zodiac_signs/1").should == {:controller => "zodiac_signs", :action => "show", :id => "1"}
    end
  
    it "should generate params { :controller => 'zodiac_signs', action => 'edit', id => '1' } from GET /zodiac_signs/1;edit" do
      params_from(:get, "/zodiac_signs/1/edit").should == {:controller => "zodiac_signs", :action => "edit", :id => "1"}
    end
  
    it "should generate params { :controller => 'zodiac_signs', action => 'update', id => '1' } from PUT /zodiac_signs/1" do
      params_from(:put, "/zodiac_signs/1").should == {:controller => "zodiac_signs", :action => "update", :id => "1"}
    end
  
    it "should generate params { :controller => 'zodiac_signs', action => 'destroy', id => '1' } from DELETE /zodiac_signs/1" do
      params_from(:delete, "/zodiac_signs/1").should == {:controller => "zodiac_signs", :action => "destroy", :id => "1"}
    end
  end
end