#---
# Excerpted from "Advanced Rails Recipes",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_arr for more book information.
#---
require File.dirname(__FILE__) + '/../../spec_helper'

describe "/zodiac_signs/index.html.erb" do
  include ZodiacSignsHelper
  
  before(:each) do
    zodiac_sign_98 = mock_model(ZodiacSign)
    zodiac_sign_98.should_receive(:name).and_return("MyString")
    zodiac_sign_98.should_receive(:sign_begins).and_return(Time.now)
    zodiac_sign_98.should_receive(:sign_ends).and_return(Time.now)
    zodiac_sign_99 = mock_model(ZodiacSign)
    zodiac_sign_99.should_receive(:name).and_return("MyString")
    zodiac_sign_99.should_receive(:sign_begins).and_return(Time.now)
    zodiac_sign_99.should_receive(:sign_ends).and_return(Time.now)

    assigns[:zodiac_signs] = [zodiac_sign_98, zodiac_sign_99]
  end

  it "should render list of zodiac_signs" do
    render "/zodiac_signs/index.html.erb"
    response.should have_tag("tr>td", "MyString", 2)
  end
end

