#---
# Excerpted from "Advanced Rails Recipes",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_arr for more book information.
#---
require File.dirname(__FILE__) + '/../../spec_helper'

describe "/zodiac_signs/new.html.erb" do
  include ZodiacSignsHelper
  
  before(:each) do
    @zodiac_sign = mock_model(ZodiacSign)
    @zodiac_sign.stub!(:new_record?).and_return(true)
    @zodiac_sign.stub!(:name).and_return("MyString")
    @zodiac_sign.stub!(:sign_begins).and_return(Time.now)
    @zodiac_sign.stub!(:sign_ends).and_return(Time.now)
    assigns[:zodiac_sign] = @zodiac_sign
  end

  it "should render new form" do
    render "/zodiac_signs/new.html.erb"
    
    response.should have_tag("form[action=?][method=post]", zodiac_signs_path) do
      with_tag("input#zodiac_sign_name[name=?]", "zodiac_sign[name]")
    end
  end
end


