#---
# Excerpted from "Advanced Rails Recipes",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_arr for more book information.
#---

module ZodiacMatchMaker
  class Like
    def initialize(expected)
      @expected = expected
    end

    
    def matches?(target)
    
      @target = target
      @target.likes?(@expected)
    
    end
    

    
    def failure_message
    
      "expected #{@target.inspect} to like  #{@expected.inspect} but doesn't!"
    
    end

    def negative_failure_message
    
      "expected #{@target.inspect} not to like #{@expected.inspect} but does!"
    
    end
    
  end
  
  
  def like(sign)
    Like.new(sign)
  end
  

end



module ZodiacMatchMakerExtension
  def method_missing(sym, *args, &block) # :nodoc:
    zodiac_signs = User.find_distinct_signs.map(&:pluralize)
    sym.to_s.scan(/like_(#{zodiac_signs.join('|')})/) do
      mock_user = mock_model(User, :sign => $1.singularize)
      return ZodiacMatchMaker::Like.new(mock_user)
    end
    super
  end
end


