#---
# Excerpted from "Advanced Rails Recipes",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_arr for more book information.
#---
require File.dirname(__FILE__) + '/../test_helper'
require 'venues_controller'

# Re-raise errors caught by the controller.
class VenuesController; def rescue_action(e) raise e end; end

class VenuesControllerTest < Test::Unit::TestCase
  def setup
    @controller = VenuesController.new
    @request    = ActionController::TestRequest.new
    @response   = ActionController::TestResponse.new
  end

  def test_should_get_index
    get :index
    assert_response :success
    assert_not_nil assigns(:venues)
  end

  def test_should_get_new
    get :new
    assert_response :success
  end

  def test_should_create_venue
    assert_difference('Venue.count') do
      post :create, :venue => { }
    end

    assert_redirected_to venue_path(assigns(:venue))
  end

  def test_should_show_venue
    get :show, :id => 1
    assert_response :success
  end

  def test_should_get_edit
    get :edit, :id => 1
    assert_response :success
  end

  def test_should_update_venue
    put :update, :id => 1, :venue => { }
    assert_redirected_to venue_path(assigns(:venue))
  end

  def test_should_destroy_venue
    assert_difference('Venue.count', -1) do
      delete :destroy, :id => 1
    end

    assert_redirected_to venues_path
  end
end
