#---
# Excerpted from "Advanced Rails Recipes",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_arr for more book information.
#---
module ApplicationHelper
  
  def error_messages_for(object_name, options = {})
    options = options.symbolize_keys
    object = instance_variable_get("@#{object_name}")
    if object && !object.errors.empty?
      messages = []
      for message in object.errors.full_messages
        messages << %(<li>#{message}</li>)
      end
      content_tag(:div, 
        content_tag(:h3, "Whoops! Please correct the following errors") +
        content_tag(:ul, messages),
        :id => 'errors')
    else
      ''
    end
  end
  
end
