#---
# Excerpted from "Advanced Rails Recipes",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_arr for more book information.
#---
class Event < ActiveRecord::Base
  
  has_many :registrations
  has_many :attendees, :through => :registrations, 
                       :source => :user
  
  extend Searchable
  search_column :name, :starts_at
                      
  validates_presence_of :name, :capacity
    
  def self.copy(other)
    self.new(other.attributes.merge(:name => "Copy of #{other.name}"))
  end
  
  def free?
    self.price == 0
  end

  def spaces_remaining
    self.capacity - self.registrations.size
  end

  def sold_out?
    spaces_remaining <= 0
  end

end
