#---
# Excerpted from "Advanced Rails Recipes",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_arr for more book information.
#---
require File.dirname(__FILE__) + '/../test_helper'

class EventsControllerTest < ActionController::TestCase

  tests EventsController

  def test_should_get_index
    get :index
    assert_response :success
    assert_not_nil assigns(:events)
  end

  def test_should_get_new
    get :new
    assert_response :success
  end

  def test_should_create_event
    assert_difference('Event.count') do
      post :create, :event => events(:rails_studio).attributes.merge("name" => "Rails 2")
    end

    assert_redirected_to event_path(assigns(:event))
  end

  def test_should_show_event
    get :show, :id => events(:rails_studio)
    assert_response :success
  end
  
  def test_should_get_edit
    get :edit, :id => events(:rails_studio)
    assert_response :success
  end

  def test_should_update_event
    put :update, :id => events(:rails_studio), :event => { }
    assert_redirected_to event_path(assigns(:event))
  end

  def test_should_destroy_event
    assert_difference('Event.count', -1) do
      delete :destroy, :id => events(:rails_studio)
    end

    assert_redirected_to events_path
  end
  
  
    context "showing an event" do
      setup { get :show, :id => events(:rails_studio) }

      should_assign_to :event
      should_respond_with :success
      should_render_template :show
      should_not_set_the_flash
    end
  
end
