#---
# Excerpted from "Advanced Rails Recipes",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_arr for more book information.
#---
require File.dirname(__FILE__) + '/../test_helper'

class UsersControllerTest < ActionController::TestCase

  tests UsersController

  def test_truth
    assert true
  end
  
  def test_create    
    assert_difference('User.count') do
      post :create, :user => {:name => "Wilma Flintstone",
                              :email => 'wilma@flintstones.com', 
                              :password => 'secret', 
                              :password_confirmation => 'secret'
                             }
      assert_response :redirect
    end
    assert session[:user_id]
  end

  def test_login_success
    post :login, :email => users(:fred).email, :password => 'test'

    assert_redirected_to events_url
    assert_equal users(:fred).id, session[:user_id]
  end

  def test_login_failure
    post :login, :email => users(:fred).email, :password => 'badpass'

    assert_response :success
    assert_nil session[:user_id]
  end

  def test_logout
    get :logout, {}, :user_id => users(:fred).id

    assert_redirected_to events_url
    assert_nil session[:user_id]
  end

end