#---
# Excerpted from "Advanced Rails Recipes",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_arr for more book information.
#---
require File.dirname(__FILE__) + '/../test_helper'

class ContactTest < ActiveSupport::TestCase

  def test_searchable
    contacts = Contact.search 'susan'
    assert_equal 1, contacts.size
    assert contacts.include?(contacts(:susan))
  
    contacts = Contact.search 'susan', :department_name
    assert_equal 0, contacts.size
    
    contacts = Contact.search 'human', :department_name
    assert_equal 2, contacts.size
    assert contacts.include?(contacts(:robert))
    assert contacts.include?(contacts(:susan))
    
    contacts = Contact.search 'rob', [:first_name, :last_name]
    assert_equal 1, contacts.size
    assert contacts.include?(contacts(:robert))
    
    contacts = Contact.search 'jack software'
    assert_equal 1, contacts.size
    assert contacts.include?(contacts(:jack))
  end
end
