#---
# Excerpted from "Advanced Rails Recipes",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_arr for more book information.
#---
require "#{File.dirname(__FILE__)}/../test_helper"


class StoryTest < ActionController::IntegrationTest

  def test_create_order
    trace_sql do
      go_to_orders
      place_order :name => 'Pierre-Alexandre', :total => 25.00
    end
  end

private

  def trace_sql
    yield
    File.open("#{RAILS_ROOT}/log/integration.sql", "w") do |file|
      queries = ActiveRecord::ConnectionAdapters::AbstractAdapter::queries.
                  join("\n")
      file.write queries
    end
  end


  def go_to_orders
    get orders_url
    assert_response :success
  end

  def place_order(options)
    post orders_url, options
    order = assigns(:order)
    assert_redirected_to order_url(order)
  end


end

