#---
# Excerpted from "Advanced Rails Recipes",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_arr for more book information.
#---
class Book < ActiveRecord::Base
  acts_as_solr :facets => [:publisher, :category, :year],
               :additional_fields => [:category, :year]

  has_and_belongs_to_many :categories

  def category
    categories.collect {|c| c.name }
  end

  def year
    published_date ? published_date.year : nil
  end
end