#!/usr/bin/env ruby
#---
# Excerpted from "Advanced Rails Recipes",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_arr for more book information.
#---


require 'rubygems'
require 'solr' 

delimited_file = 'sample_export.txt' 
books = Solr::Importer::DelimitedFileSource.new(delimited_file) 

mapping = { 
  :id              => :asin, 
  :author_text     => :author, 
  :title_text      => :fullTitle, 
  :publisher_facet => :publisher, 
  :category_facet  => 
    Proc.new { |data| data[:genre].split('/').map {|s| s.strip}}, 
  :year_facet      => 
    Proc.new { |data| data[:published].scan(/\d\d\d\d/)[0] }
}

indexer = Solr::Indexer.new(books, mapping) 
indexer.index

