#---
# Excerpted from "Advanced Rails Recipes",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_arr for more book information.
#---
require File.dirname(__FILE__) + '/../test_helper'

class BooksControllerTest < ActionController::TestCase
  tests BooksController

  def test_should_get_index
    get :index
    assert_response :success
    assert_not_nil assigns(:books)
  end

  def test_should_get_new
    get :new
    assert_response :success
  end

  def test_should_create_book
    assert_difference('Book.count') do
      post :create, :book => { }
    end

    assert_redirected_to book_path(assigns(:book))
  end

  def test_should_show_book
    get :show, :id => 1
    assert_response :success
  end

  def test_should_get_edit
    get :edit, :id => 1
    assert_response :success
  end

  def test_should_update_book
    put :update, :id => 1, :book => { }
    assert_redirected_to book_path(assigns(:book))
  end

  def test_should_destroy_book
    assert_difference('Book.count', -1) do
      delete :destroy, :id => 1
    end

    assert_redirected_to books_path
  end
end
