#---
# Excerpted from "Advanced Rails Recipes",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_arr for more book information.
#---
# Table fields for 'electronics'
# - id
# - name
# - manufacturer
# - features
# - category
# - price

class Electronic < ActiveRecord::Base
  acts_as_solr :facets => [:category, :manufacturer],
               :fields => [:name, :manufacturer, :features, :category, {:price => {:type => :range_float, :boost => 10.0}}],
               :boost  => 5.0, 
               :exclude_fields => [:features]

  # The following example would also convert the :price field type to :range_float
  # 
  # acts_as_solr :facets => [:category, :manufacturer],
  #              :fields => [:name, :manufacturer, :features, :category, {:price => :range_float}],
  #              :boost  => 5.0
end
