require 'hpricot'
require 'open-uri'

ENV['RAILS_ENV'] ||= "development"
 
namespace :rails_api do  

  desc "Import the Rails API docs"
  task :import => :environment do
    Dir['public/api/**/*.html'].each do |file|
      doc = Hpricot(open(file))
      title = (doc/"title").text
      
      category = ''
      if title =~ /\AClass\: /
        category = 'Class'
      elsif title =~ /\AModule\: /
        category = 'Module'
      elsif title =~ /\AFile\: /
        category = 'File'
      end
      
      Document.create!(:title     => title,
                       :category  => category,
                       :file_path => file, 
                       :content   => File.read(file))
    end
  end
end
