#---
# Excerpted from "Advanced Rails Recipes",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_arr for more book information.
#---

require 'fileutils'
require 'chronic'
require 'singleton'

if defined? RAILS_ENV and RAILS_ENV == "development"
  if ENV['USER'] == 'eweaver'
    require 'ruby-debug'
    Debugger.start
  end
end

$LOAD_PATH << "#{File.dirname(__FILE__)}/../vendor/riddle/lib"
require 'riddle'

require 'ultrasphinx/ultrasphinx'
require 'ultrasphinx/core_extensions'
require 'ultrasphinx/is_indexed'

if (ActiveRecord::Base.connection rescue nil)
  require 'ultrasphinx/configure'
  require 'ultrasphinx/autoload'
  require 'ultrasphinx/fields'

  require 'ultrasphinx/search/internals'
  require 'ultrasphinx/search/parser'
  require 'ultrasphinx/search'

  begin
    require 'raspell'
  rescue Object => e
  end
  
  require 'ultrasphinx/spell'
end

