#---
# Excerpted from "Advanced Rails Recipes",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_arr for more book information.
#---
class Geo::Address < ActiveRecord::Base
  belongs_to :user
  belongs_to :state, :class_name => 'Geo::State'
  
  is_indexed 'fields' => ['name'],
    'concatenate' => [{'fields' => ['line_1', 'line_2', 'city', 'province_region', 'zip_postal_code'], 'as' => 'content'}],
    'include' => [{'class_name' => 'Geo::State', 'field' => 'name', 'as' => 'state'}]
end
