#---
# Excerpted from "Advanced Rails Recipes",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_arr for more book information.
#---

require "#{File.dirname(__FILE__)}/../test_helper"

class ConfigureTest < Test::Unit::TestCase
  
  CONF = "#{RAILS_ROOT}/config/ultrasphinx/development.conf"
  
  def test_configuration_hasnt_changed

    File.delete CONF if File.exist? CONF
    Dir.chdir RAILS_ROOT do
      Ultrasphinx::Configure.run
    end

    @offset = 4
    @current = open(CONF).readlines[@offset..-1]
    @canonical = open(CONF + ".canonical").readlines[@offset..-1] 
    @canonical.each_with_index do |line, index|
       assert_equal line, @current[index], "line #{index}:#{line.inspect} is incorrect"
    end
  end

end