#---
# Excerpted from "Advanced Rails Recipes",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_arr for more book information.
#---
class Album < ActiveRecord::Base
  
  has_many :songs

  attr_accessor :uploaded_song_data
  
  
  def save_with_song
    song = Song.new

    begin
      self.transaction do
        if uploaded_song_data && uploaded_song_data.size > 0
          song.uploaded_data = uploaded_song_data
          song.thumbnails.clear
          song.name = uploaded_song_data.original_filename
          song.save!    
          self.songs << song
        end
        save!
      end
    rescue
      if song.errors.on(:size)
        errors.add_to_base("Uploaded file is too big (500-KB max).")       
      end
      if song.errors.on(:content_type)
        errors.add_to_base("Uploaded file content-type is not valid.") 
      end
      false
    end
  end
  
  
end
