#---
# Excerpted from "Advanced Rails Recipes",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_arr for more book information.
#---
class Song < ActiveRecord::Base
  belongs_to :album
  has_attachment :content_type => 'audio/mpeg', 
                 :storage => :file_system, 
                 :max_size => 2.megabytes

  validates_as_attachment
  

  def after_attachment_saved
    STARLING.set('s3_uploads', 
                 {:file_name   => self.full_filename,
                  :public_path => self.public_filename})
  end

  
  def listen_url
    if File.exists?(full_filename)
      public_filename
    else
      s3 = S3Uploader.new(full_filename, public_filename)
      s3.url
    end
  end
  

end
