#---
# Excerpted from "Advanced Rails Recipes",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_arr for more book information.
#---
require File.dirname(__FILE__) + '/../test_helper'

class AlbumsControllerTest < ActionController::TestCase
  def test_should_get_index
    get :index
    assert_response :success
    assert_not_nil assigns(:albums)
  end

  def test_should_get_new
    get :new
    assert_response :success
  end

  def test_should_create_album
    assert_difference('Album.count') do
      post :create, :album => { }
    end

    assert_redirected_to album_path(assigns(:album))
  end

  def test_should_show_album
    get :show, :id => 1
    assert_response :success
  end

  def test_should_get_edit
    get :edit, :id => 1
    assert_response :success
  end

  def test_should_update_album
    put :update, :id => 1, :album => { }
    assert_redirected_to album_path(assigns(:album))
  end

  def test_should_destroy_album
    assert_difference('Album.count', -1) do
      delete :destroy, :id => 1
    end

    assert_redirected_to albums_path
  end
end
