#---
# Excerpted from "Advanced Rails Recipes",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_arr for more book information.
#---
require File.dirname(__FILE__) + '/test_helper'

class SetupTest < Test::Unit::TestCase
  def setup
    @controller = SeleniumController.new
    @request    = ActionController::TestRequest.new
    @response   = ActionController::TestResponse.new
  end

  def test_session_reset
    @request.session['key'] = 'value'
    get :setup
    assert_nil session['key']
    assert_response :success
    assert_tag :content => 'The session is wiped clean.'
  end
  
  def test_session_no_reset
    @request.session['key'] = 'value'
    get :setup, :keep_session => true
    assert_equal 'value', session['key']
    assert_response :success
    assert_no_tag :content => 'The session is wiped clean.'
  end
  
  #
  # Don't have the nerve to test fixtures since this is a plugin
  #
end
