#---
# Excerpted from "Advanced Rails Recipes",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_arr for more book information.
#---
class AlbumsController < ApplicationController
  # GET /albums
  # GET /albums.xml
  def index
    @albums = Album.find(:all)

    respond_to do |format|
      format.html # index.html.erb
      format.xml  { render :xml => @albums }
    end
  end

  # GET /albums/1
  # GET /albums/1.xml
  def show
    @album = Album.find(params[:id])

    respond_to do |format|
      format.html # show.html.erb
      format.xml  { render :xml => @album }
    end
  end

  # GET /albums/new
  # GET /albums/new.xml
  def new
    @album = Album.new

    respond_to do |format|
      format.html # new.html.erb
      format.xml  { render :xml => @album }
    end
  end

  # GET /albums/1/edit
  def edit
    @album = Album.find(params[:id])
  end


  
  def create
    @album = Album.new(params[:album])
    @cover = Cover.new(:uploaded_data => params[:cover_file])
    
    @service = AlbumService.new(@album, @cover)
    
    respond_to do |format|
      if @service.save
        flash[:notice] = 'Album was successfully created.'
        format.html { redirect_to(@album) }
        format.xml  { render :xml      => @album, 
                             :status   => :created, 
                             :location => @album }
      else
        format.html { render :action => :new }
        format.xml  { render :xml    => @album.errors, 
                             :status => :unprocessable_entity }
      end
    end
  end
  

  
  def update
    @album = Album.find(params[:id])
    @cover = @album.cover
    
    @service = AlbumService.new(@album, @cover)

    respond_to do |format|
      if @service.update_attributes(params[:album], params[:cover_file])
        flash[:notice] = 'Album was successfully updated.'
        format.html { redirect_to @album }
        format.xml  { head :ok }
      else
        @cover = @service.cover
        format.html { render :action => :edit }
        format.xml  { render :xml    => @album.errors, 
                             :status => :unprocessable_entity }
      end
    end
  end
  

  # DELETE /albums/1
  # DELETE /albums/1.xml
  def destroy
    @album = Album.find(params[:id])
    @album.destroy

    respond_to do |format|
      format.html { redirect_to(albums_url) }
      format.xml  { head :ok }
    end
  end
end
