#---
# Excerpted from "Advanced Rails Recipes",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_arr for more book information.
#---

class AlbumService
  
  attr_reader :album, :cover
  
  def initialize(album, cover)
    @album = album
    @cover = cover
  end
  
  def save
    return false unless valid?
    begin
      Album.transaction do
        if @cover.new_record?
          @album.cover.destroy if @album.cover
          @cover.album = @album
          @cover.save!
        end
        @album.save!
        true
      end
    rescue
      false
    end
  end

  def valid?
    @album.valid? && @cover.valid?
  end
  
  
  
  def update_attributes(album_attributes, cover_file)
    @album.attributes = album_attributes
    unless cover_file.blank?
      @cover = Cover.new(:uploaded_data => cover_file)
    end
    save
  end
  
  

end

