#---
# Excerpted from "Advanced Rails Recipes",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_arr for more book information.
#---
class Article < ActiveRecord::Base  
  
  def self.find_publicly_viewable(*args)
    with_publicly_viewable { find(*args) }
  end

  def self.calculate_publicly_viewable(*args)
    with_publicly_viewable { calculate(*args) }
  end

  def self.with_publicly_viewable
    with_scope(:find => 
                 {:conditions => ["draft = ? AND publish_date <= ?", 
                                  false, Time.now]}) do
      yield
    end
  end
  
  def self.with_premium
    with_scope(:find => {:conditions => {:premium => true}}) do
      yield
    end
  end
end