#---
# Excerpted from "Advanced Rails Recipes",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_arr for more book information.
#---
# Usage: date.to_s(:available_on)
#
# Defaults:
#  :short  => "%e %b"
#  :long   => "%B %e, %Y"
#  :db     => "%Y-%m-%d"
#  :rfc822 => "%e %b %Y"


ActiveSupport::CoreExtensions::Date::Conversions::DATE_FORMATS.merge!(
  :weekday => "%A: %B %d, %Y"
)


# Usage: time.to_s(:order_placed)
#
# Defaults:
#  :db     => "%Y-%m-%d %H:%M:%S"
#  :time   => "%H:%M"
#  :short  => "%d %b %H:%M"
#  :long   => "%B %d, %Y %H:%M"
#  :rfc822 => "%a, %d %b %Y %H:%M:%S %z"

ActiveSupport::CoreExtensions::Time::Conversions::DATE_FORMATS.merge!(
  :chatty => "%I:%M %p %Z on %B %d, %Y"
)
