#---
# Excerpted from "Advanced Rails Recipes",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_arr for more book information.
#---
# Filters added to this controller apply to all controllers in the application.
# Likewise, all the methods added will be available for all controllers.

class ApplicationController < ActionController::Base
  helper :all # include all helpers, all the time

  # See ActionController::RequestForgeryProtection for details
  # Uncomment the :secret if you're not using the cookie session store
  protect_from_forgery # :secret => '7e51b27b550ab17a5b8ee4b76156151c'

  filter_parameter_logging :password
  helper_method :logged_in?, :current_user

protected 

  def authorize 
    unless logged_in? && current_user
      flash[:notice] = "Please log in" 
      redirect_to login_url
    end 
  end

  # Returns true or false if the user is logged in.
  def logged_in?
    session[:user_id]
  end

  # Accesses the current user from the session.
  def current_user
    @current_user ||= User.find_by_id(session[:user_id])
  end

end