#---
# Excerpted from "Advanced Rails Recipes",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_arr for more book information.
#---
class UsersController < ApplicationController

  def new
    @user = User.new
  end
  
  def create
    @user = User.new(params[:user])
    if @user.save
      session[:user_id] = @user.id
      flash[:notice] = "Thanks for signing up!"
      redirect_to events_url
    else
      render :action => :new
    end
  end
  
  def login
    if request.post?
      user = User.authenticate(params[:email], params[:password])
      if user
        session[:user_id] = user.id
        flash[:notice] = "Welcome back, #{user.name}!"
        redirect_to events_url
      else
        flash[:error] = "Invalid email/password combination!"
      end
    end
  end  
  
  def logout
    session[:user_id] = nil
    flash[:notice] = "You've been logged out."
    redirect_to events_url
  end

end
