#---
# Excerpted from "Advanced Rails Recipes",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_arr for more book information.
#---
module Html
  module Test
    class ValidateFilter
      attr_accessor :request, :response, :params, :validators
      
      include ::Test::Unit::Assertions
      include ::Html::Test::Assertions

      def initialize(controller)
        self.request = controller.request
        self.response = controller.response
        self.params = controller.params
        self.validators = controller.class.validators
      end

      def validate_page
        return if !should_validate?
        assert_validates(validators, response.body.strip)        
      end

      # Override this method if you only want to validate a subset of pages
      def should_validate?
        response.headers['Status'] =~ /200/ and
        (response.headers['Content-Type'] =~ /text\/html/i or
        response.body =~ /<html/)
      end
    end
  end
end
