#---
# Excerpted from "Advanced Rails Recipes",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/fr_arr for more book information.
#---
# Filters added to this controller apply to all controllers in the application.
# Likewise, all the methods added will be available for all controllers.


class ApplicationController < ActionController::Base

  helper :all # include all helpers, all the time

  # See ActionController::RequestForgeryProtection for details
  # Uncomment the :secret if you're not using the cookie session store
  protect_from_forgery # :secret => 'e6be9bb50b2ded04fba23e73063200ae'
  

  before_filter :adjust_format_for_iphone
    
  helper_method :iphone_user_agent?

protected

  def adjust_format_for_iphone
    # iPhone sub-domain request
    # request.format = :iphone if iphone_subdomain?
  
    # Detect from iPhone user-agent
    request.format = :iphone if iphone_user_agent?  
  end

  # Request from an iPhone or iPod touch? 
  # (Mobile Safari user agent)
  def iphone_user_agent?
    request.env["HTTP_USER_AGENT"] && 
    request.env["HTTP_USER_AGENT"][/(Mobile\/.+Safari)/]
  end

  def iphone_subdomain?
    return request.subdomains.first == "iphone"
  end
end

